commit:     86c66f18359d1521517820a84325a6e8fec93b85
Author:     Pacho Ramos <pacho <AT> gentoo <DOT> org>
AuthorDate: Sun Mar 28 08:52:55 2021 +0000
Commit:     Pacho Ramos <pacho <AT> gentoo <DOT> org>
CommitDate: Sun Mar 28 08:52:55 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=86c66f18

gnome-base/gnome-session: Fix conflict with systemd v247

Upstream patch from 'master' to fix indirect conflict with exit.target via
app.slice

Closes: https://bugs.gentoo.org/758752
Package-Manager: Portage-3.0.17, Repoman-3.0.2
Signed-off-by: Pacho Ramos <pacho <AT> gentoo.org>

 ...e-session-3.38.0-exit-conflict-systemd247.patch |  56 ++++++++++
 .../gnome-session/gnome-session-3.38.0-r1.ebuild   | 123 +++++++++++++++++++++
 2 files changed, 179 insertions(+)

diff --git 
a/gnome-base/gnome-session/files/gnome-session-3.38.0-exit-conflict-systemd247.patch
 
b/gnome-base/gnome-session/files/gnome-session-3.38.0-exit-conflict-systemd247.patch
new file mode 100644
index 00000000000..a4a99640f37
--- /dev/null
+++ 
b/gnome-base/gnome-session/files/gnome-session-3.38.0-exit-conflict-systemd247.patch
@@ -0,0 +1,56 @@
+From 9de6e40f12e8878f524f8d429d85724c156a0517 Mon Sep 17 00:00:00 2001
+From: Benjamin Berg <[email protected]>
+Date: Thu, 3 Dec 2020 13:45:36 +0100
+Subject: [PATCH] data: Fix indirect conflict with exit.target via app.slice
+
+systemd v247 now puts services into app.slice by default. But app.slice
+will have a conflict with exit.target, which in turn means that we still
+get a conflict with exit.target indirectly.
+
+Fix it by adding the appropriate Slice=-.slice into
+gnome-session-restart-dbus.service. Also update the note in
+gnome-session-shutdown.service to point out the requirements.
+
+Closes: #74
+---
+ data/gnome-session-restart-dbus.service.in | 5 +++--
+ data/gnome-session-shutdown.target         | 5 +++--
+ 2 files changed, 6 insertions(+), 4 deletions(-)
+
+diff --git a/data/gnome-session-restart-dbus.service.in 
b/data/gnome-session-restart-dbus.service.in
+index e90f6bc8..6389c321 100644
+--- a/data/gnome-session-restart-dbus.service.in
++++ b/data/gnome-session-restart-dbus.service.in
+@@ -1,10 +1,11 @@
+ [Unit]
+ Description=Restart DBus after GNOME Session shutdown
+ 
+-# Allow exit.target to start even if this unit is started with 
replace-irreversibly
+-# Also put it into a slice that doesn't have such implicit dependencies
++# Allow exit.target to start even if this unit is started with 
replace-irreversibly.
++# For this to work, we also need to be in the root slice.
+ DefaultDependencies=no
+ 
+ [Service]
+ Type=notify
+ ExecStart=@libexecdir@/gnome-session-ctl --restart-dbus
++Slice=-.slice
+diff --git a/data/gnome-session-shutdown.target 
b/data/gnome-session-shutdown.target
+index 607dc6e7..2c3d1963 100644
+--- a/data/gnome-session-shutdown.target
++++ b/data/gnome-session-shutdown.target
+@@ -1,8 +1,9 @@
+ [Unit]
+ Description=Shutdown running GNOME Session
+ 
+-# Allow exit.target to start even if this unit is started with 
replace-irreversibly
+-# The same is needed for all (weak) dependencies
++# Allow exit.target to start even if this unit is started with 
replace-irreversibly.
++# All (weak) dependencies need to do the same. Services also need to ensure 
they
++# are in the root slice by setting Slice=-.slice.
+ DefaultDependencies=no
+ 
+ Conflicts=graphical-session.target graphical-session-pre.target
+-- 
+GitLab
+

diff --git a/gnome-base/gnome-session/gnome-session-3.38.0-r1.ebuild 
b/gnome-base/gnome-session/gnome-session-3.38.0-r1.ebuild
new file mode 100644
index 00000000000..88737c316d3
--- /dev/null
+++ b/gnome-base/gnome-session/gnome-session-3.38.0-r1.ebuild
@@ -0,0 +1,123 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+inherit desktop gnome.org gnome2-utils meson xdg
+
+DESCRIPTION="Gnome session manager"
+HOMEPAGE="https://gitlab.gnome.org/GNOME/gnome-session";
+
+LICENSE="GPL-2+"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~ia64 ~ppc ~ppc64 ~sparc ~x86 ~amd64-linux 
~x86-linux ~x86-solaris"
+IUSE="doc elogind systemd"
+# There is a null backend available, thus ?? not ^^
+REQUIRED_USE="?? ( elogind systemd )"
+
+DEPEND="
+       >=dev-libs/glib-2.46.0:2
+       >=x11-libs/gtk+-3.22.0:3
+       x11-libs/libICE
+       x11-libs/libSM
+       x11-libs/libX11
+       >=gnome-base/gnome-desktop-3.34.2:3=
+       >=dev-libs/json-glib-0.10
+       media-libs/mesa[egl,gles2,X(+)]
+       media-libs/libepoxy
+       x11-libs/libXcomposite
+
+       systemd? ( >=sys-apps/systemd-242:0= )
+       elogind? ( >=sys-auth/elogind-239.4 )
+"
+
+# Pure-runtime deps from the session files should *NOT* be added here.
+# >=gnome-settings-daemon-3.35.91 for UsbProtection required component.
+# x11-misc/xdg-user-dirs{,-gtk} are needed to create the various XDG_*_DIRs, 
and
+# create .config/user-dirs.dirs which is read by glib to get G_USER_DIRECTORY_*
+# xdg-user-dirs-update is run during login (see 10-user-dirs-update-gnome 
below).
+# sys-apps/dbus[X] is needed for session management.
+# Our 90-xcursor-theme-gnome reads a setting from gsettings-desktop-schemas.
+RDEPEND="${DEPEND}
+       >=gnome-base/gnome-settings-daemon-3.35.91
+       >=gnome-base/gsettings-desktop-schemas-0.1.7
+       sys-apps/dbus[X]
+
+       x11-misc/xdg-user-dirs
+       x11-misc/xdg-user-dirs-gtk
+"
+BDEPEND="
+       dev-libs/libxslt
+       dev-util/gdbus-codegen
+       >=sys-devel/gettext-0.19.8
+       x11-libs/xtrans
+       virtual/pkgconfig
+       doc? ( app-text/xmlto
+               app-text/docbook-xml-dtd:4.1.2 )
+"
+
+PATCHES=(
+       "${FILESDIR}"/${P}-meson-Support-elogind.patch
+       # Fix indirect conflict with exit.target via app.slice (from 'master')
+       "${FILESDIR}"/${PN}-3.38.0-exit-conflict-systemd247.patch
+)
+
+src_prepare() {
+       xdg_src_prepare
+       # Install USE=doc in $PF if enabled
+       sed -i -e "s:meson\.project_name(), 'dbus':'${PF}', 'dbus':" 
doc/dbus/meson.build || die
+}
+
+src_configure() {
+       local emesonargs=(
+               -Ddeprecation_flags=false
+               $(meson_use elogind)
+               -Dsession_selector=true # gnome-custom-session
+               $(meson_use systemd)
+               -Dsystemd_session=$(usex systemd default disable)
+               $(meson_use systemd systemd_journal)
+               $(meson_use doc docbook)
+               -Dconsolekit=false
+               -Dman=true
+       )
+       meson_src_configure
+}
+
+src_install() {
+       meson_src_install
+
+       exeinto /etc/X11/Sessions
+       doexe "${FILESDIR}/Gnome"
+
+       newmenu "${FILESDIR}/defaults.list-r5" gnome-mimeapps.list
+
+       exeinto /etc/X11/xinit/xinitrc.d/
+       newexe "${FILESDIR}/15-xdg-data-gnome-r1" 15-xdg-data-gnome
+
+       # This should be done here as discussed in bug #270852
+       newexe "${FILESDIR}/10-user-dirs-update-gnome-r1" 
10-user-dirs-update-gnome
+
+       # Set XCURSOR_THEME from current dconf setting instead of installing
+       # default cursor symlink globally and affecting other DEs (bug #543488)
+       # https://bugzilla.gnome.org/show_bug.cgi?id=711703
+       newexe "${FILESDIR}/90-xcursor-theme-gnome" 90-xcursor-theme-gnome
+}
+
+pkg_postinst() {
+       xdg_pkg_postinst
+       gnome2_schemas_update
+
+       if ! has_version gnome-base/gdm && ! has_version x11-misc/sddm; then
+               ewarn "If you use a custom .xinitrc for your X session,"
+               ewarn "make sure that the commands in the xinitrc.d scripts are 
run."
+       fi
+
+       if ! use systemd && ! use elogind; then
+               ewarn "You are building without systemd or elogind support."
+               ewarn "gnome-session won't be able to correctly track and 
manage your session."
+       fi
+}
+
+pkg_postrm() {
+       xdg_pkg_postinst
+       gnome2_schemas_update
+}

Reply via email to